﻿using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGCursorAtEndCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void XamDataGrid_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            DependencyObject cell = Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject, typeof(CellValuePresenter), false);
            if (cell != null)
            {
                CellValuePresenter cvp = (CellValuePresenter)cell;
                cvp.StartEditMode();

                if (cvp.Editor is XamTextEditor)
                {
                    XamTextEditor textEditor = cvp.Editor as XamTextEditor;
                    int caretPos = CalculateCaretForTextEditor(textEditor, e);

                    textEditor.SelectionStart = caretPos;
                    textEditor.SelectionLength = 0;
                }
                if (cvp.Editor is XamNumericEditor)
                {
                    XamNumericEditor numEditor = cvp.Editor as XamNumericEditor;
                    int caretPos = CalculateCaretForNumericEditor(numEditor, e);

                    numEditor.SelectionStart = caretPos;
                    numEditor.SelectionLength = 0;
                }

                e.Handled = true;

            }     
        }

        private int CalculateCaretForNumericEditor(XamNumericEditor numEditor, MouseButtonEventArgs e)
        {
            TextBox editorTextBox = (TextBox)Utilities.GetDescendantFromType(numEditor, typeof(TextBox), true);
           
            int caretPos = editorTextBox.Text.Length;            
                        
            return caretPos;
        }

        private int CalculateCaretForTextEditor(XamTextEditor textEditor, MouseButtonEventArgs e)
        {
            TextBox editorTextBox = (TextBox)Utilities.GetDescendantFromType(textEditor, typeof(TextBox), true);
            
            int caretPos = editorTextBox.Text.Length;
            
            return caretPos;        
        }        
    }
}
